function adaptive_spline_linear = adaptive_spline_linear(epsilon,waittime)
  
    % immer einheitsintervall!
    G = [0,1];
    ep = quad("f1_abl2_abs",0,1);
    % wir starten ganz links bei 0.
    currentPos = 0;
    i = 1;
    % das fenster soll einigerma�en fullscreen sein.
    s = get(0, 'ScreenSize');
    figure('Position', [0 0 s(3) s(4)]);
    % und jetzt plotten wir die ausgangsposition.
    % d.h. wir plotten die eigentliche funktion f1.
    x1 = linspace(0,1,1000);
    y1 = zeros(1,length(x1));
    for i=1:1:length(x1)
        y1(i) = f1(x1(i));
    end
    % und wir plotten die entsprechende stufenfunktion.
    % die funktion geh�rt dann zu G.
    x2 = zeros(1,2);
    y2 = zeros(1,2);
    x2(1) = 0;
    x2(2) = 1;
    y2(1) = f1(0);
    y2(2) = f1(1);
    plot(x1,y1,x2,y2,'color', 'red');
    % damit das ergebnis gut zu erkennen ist, pausieren wir kurz.
    pause(waittime);
    % wenn wir noch nicht genug verfeinerung haben, verfeinere.
    if epsilon < ep
        while currentPos < 1
            % finde den index in der knotenmenge G.
            n = length(G);
            i = n;
            for k=1:1:n-1
                if currentPos >= G(k) && currentPos < G(k+1)
                    i = k;
                end
            end
            % berechne den aktuellen fehler.
	    % man beachte, dass bei der fehlerberechnung wieder ein fehler gemacht wird.
	    % dies ignorieren wir der einfachheit halber.
            ep = quad("f1_abl2_abs",G(i),G(i+1));
            % wenn der fehler f�r dieses intervall klein genug ist, gehen wir einen knoten weiter.
            if ep <= epsilon
                currentPos = G(i+1);
                % i = i + 1;
                % ansonsten f�gen wir einen knoten hinzu.
                % wir nehmen hier dyadische knoten.
            else
                % f�ge jetzt den neuen knoten ein.
                newKnot = (G(i)+G(i+1))/2;
                H = zeros(1,n+1);
                H(i+1) = newKnot;
                for k=1:1:i
                    H(k) = G(k);
                end
                for l=i+2:1:n+1
                    H(l) = G(l-1);
                end
                G = H;
                % plotten wieder das zwischenergebnis.
                x2 = zeros(1,length(G));
                y2 = zeros(1,length(G));
                for i=1:1:length(G)
                    x2(i) = G(i);
                    y2(i) = f1(G(i));
                end
                plot(x1,y1,x2,y2,'color', 'red');
                pause(waittime);
            end
        end
    end
endfunction

function y = f1_abs(x)
    y = abs(f1(x));
endfunction

function y = f1_abl_abs(x)
    y = abs(f1_abl(x));
endfunction

function y = f1_abl2_abs(x)
    y = abs(f1_abl2(x));
endfunction
